<template>
  <modal name="statements-list"
         class="arcticmodal-container full-viewport"
         width="600"
         height="auto"
         :adaptive=true
         @before-open="beforeOpen"
         @before-close="beforeClose">
    <div class="container m-header">
      <div @click="close()" class="box-modal_close arcticmodal-close"></div>
      <div class="row">
        <div class="column">
          <h3>Список заявлений по займу</h3>
        </div>
      </div>
    </div>
    <div class="container content feedback-block">
      <ajax-loader v-if="loading"></ajax-loader>
      <p v-if="!loading && !statements">Нет доступных для подачи заявлений</p>
      <div v-else v-for="statement in statements" class="row details">
        <a @click.prevent="openDocument(statement.type, statement.button)" href="#">
          <div class="picto">
            <img src="/lk/static/img/notification/docs.png" alt="">
          </div>
          {{ statement.title }}
        </a>
      </div>
      <vuex-error-block/>
    </div>
    <statements-apply @apply="apply" :button="button"/>
  </modal>
</template>
<script>
  import {getStatementsByLoanId, getStatementsByLoanIdAndType, putStatementsByLoanIdAndType} from '@/utils/api'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import {UNSET_ERRORS} from '@/store/mutation-types'
  import StatementsApply from '@/components/Modals/StatementApply'

export default {
    name: 'statements-list',
    data () {
      return {
        loading: true,
        params: {},
        statements: [],
        button: true
      }
    },
    mixins: [
      ErrorHandleMixin
    ],
    components: {
      StatementsApply
    },
    methods: {
      async beforeOpen (event) {
        this.$helpers.noscroll(true);
        this.statements = []
        this.params = event.params
        this.getStatement()
      },
      async getStatement () {
        this.loading = true
        try {
          const statements = await getStatementsByLoanId(this.params.creditId)
          this.statements = statements
          this.loading = false
        } catch (e) {
          this.loading = false
        }
      },
      async openDocument (type, button) {
        this.loading = true
        const {data} = await getStatementsByLoanIdAndType(this.params.creditId, type)
        this.button = button
        this.loading = false
        this.$modal.show('statements-apply', data)
      },
      async apply (type) {
        try {
          this.loading = true
          await putStatementsByLoanIdAndType(this.params.creditId, type)
          await this.getStatement()
        } catch (e) {
          this.loading = false
        }
      },
      beforeClose () {
        this.$store.commit(UNSET_ERRORS)
        this.$helpers.noscroll(false);
      },
      close () {
        this.$modal.hide('statements-list')
      }
    }
  }
</script>
<style scoped>
  h3 {
    margin-bottom: 0px !important;
  }
  .buttons {
    text-align: center
  }
</style>
